;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: DAC8.inc
;;   Version: 2.2, Updated on 2012/3/2 at 9:13:52
;;  Generated by PSoC Designer 5.2.2551
;;
;;  DESCRIPTION:  Assembler declarations for the DAC8 user module interface.
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress Semiconductor 2012. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

;--------------------------------------------------
; Constants for DAC8 API's
;--------------------------------------------------

DAC8_OFF:              equ 00h
DAC8_LOWPOWER:         equ 01h
DAC8_MEDPOWER:         equ 02h
DAC8_HIGHPOWER:        equ 03h

DAC8_LSB_CR0:          equ 98h
DAC8_LSB_CR1:          equ 99h
DAC8_LSB_CR2:          equ 9ah
DAC8_LSB_CR3:          equ 9bh
DAC8_MSB_CR0:          equ 88h
DAC8_MSB_CR1:          equ 89h
DAC8_MSB_CR2:          equ 8ah
DAC8_MSB_CR3:          equ 8bh

DAC8_OffsetBinary:     equ 04h
DAC8_TwosComplement:   equ 02h
DAC8_SignAndMagnitude: equ 01h
DAC8_RawRegister:      equ 00h

DAC8_DATAFORMAT:       equ 3h
DAC8_OFFSETBINARY:     equ DAC8_DATAFORMAT & DAC8_OffsetBinary
DAC8_TWOSCOMPLEMENT:   equ DAC8_DATAFORMAT & DAC8_TwosComplement
DAC8_SIGNANDMAGNITUDE: equ DAC8_DATAFORMAT & DAC8_SignAndMagnitude

DAC8_PHASE_Normal:     equ 0
DAC8_PHASE_Swapped:    equ 1

DAC8_PHASE_SWAP:       equ DAC8_PHASE_Normal

IF DAC8_PHASE_SWAP
    DAC8_CR0_HIBITS:   equ C0h
ELSE
    DAC8_CR0_HIBITS:   equ 80h
ENDIF

;--------------------------------------------------
; Register Address Constants for DAC8
;--------------------------------------------------
DAC8_LSB_CR0:   equ 98h                          ; LSB SC Block Control Register 0
DAC8_LSB_CR1:   equ 99h                          ; LSB SC Block Control Register 1
DAC8_LSB_CR2:   equ 9ah                          ; LSB SC Block Control Register 2
DAC8_LSB_CR3:   equ 9bh                          ; LSB SC Block Control Register 3

DAC8_MSB_CR0:   equ 88h                          ; MSB SC Block Control Register 0
DAC8_MSB_CR1:   equ 89h                          ; MSB SC Block Control Register 1
DAC8_MSB_CR2:   equ 8ah                          ; MSB SC Block Control Register 2
DAC8_MSB_CR3:   equ 8bh                          ; MSB SC Block Control Register 3

; end of file DAC8.inc
